package com.sa.ibiz.demo.demoapp.controller.demo;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.sql.Timestamp;
import javax.annotation.Resource;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.Data;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.sa.ibiz.demo.ibizutil.domain.ActionResult;
import com.sa.ibiz.demo.demo.service.OrgService;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import com.sa.ibiz.demo.demo.domain.Org;
import com.sa.ibiz.demo.demo.service.dto.OrgSearchFilter;
import com.sa.ibiz.demo.demoapp.controller.demo.vo.*;
import org.springframework.cglib.beans.BeanGenerator;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.util.StringUtils;
import java.io.IOException;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.validation.annotation.Validated;
import org.springframework.http.ResponseEntity;
import org.springframework.beans.factory.annotation.Autowired;
import com.sa.ibiz.demo.ibizutil.domain.RedirectResult;
import javax.validation.constraints.NotBlank;
import com.sa.ibiz.demo.ibizutil.domain.AutoCompleteItem;
import java.math.BigInteger;
import com.alibaba.fastjson.JSONObject;

@RestController
@RequestMapping("/demoapp/demo/org")
public class OrgController{



    @Autowired
	private OrgService orgService;
	/**
	 * 获取服务对象
	*/
	protected OrgService getService(){
		return this.orgService;
	}
	/**
	 * 实体界面行为
	 * @param param 参数集合
	 * @return
	 */
	@PostMapping(value="uiaction/initall")
	public ResponseEntity<JSONObject>uiactionInitall(@RequestBody Map param) {
		String strkey="";
		JSONObject obj =new JSONObject();
		Org entity=new Org();
		String srfkeys=param.get("srfkeys").toString();
		String srfkeyArr[] =srfkeys.split(";");
		for(String srfkey : srfkeyArr){
			if(!StringUtils.isEmpty(srfkey)){
				entity.setOrgid(srfkey);
				this.getService().get(entity);
			}
			this.getService().initAll(entity);
		}
		obj.put("success",true);
		obj.put("info","初始化机构相关数据完成！");
		obj.put("reloadData",false);
		return ResponseEntity.ok().body(obj);
	}



	@PostMapping(value="main2editform/update")
	public ResponseEntity<Org_EditForm_Main2> main2EditFormUpdate(@Validated @RequestBody Org_EditForm_Main2 form){
            Org entity =form.toOrg();
            getService().update(entity);
            form.fromOrg(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="main2editform/remove")
	public ResponseEntity<Org_EditForm_Main2> main2EditFormRemove(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            Org_EditForm_Main2 form=new Org_EditForm_Main2();
            Org entity = new Org();
            entity.setOrgid(srfkey);
            getService().remove(entity);
            form.setSrfuf("0");
            form.fromOrg(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="main2editform/getdraft")
	public ResponseEntity<Org_EditForm_Main2> main2EditFormGetDraft(@RequestBody Org_EditForm_Main2 form){
        if(!StringUtils.isEmpty(form.getSrfsourcekey()))
        {
            Org sourceEntity =new Org();
            sourceEntity.setOrgid(form.getSrfsourcekey());
            this.getService().get(sourceEntity);

			Org targetEntity =new Org();
			sourceEntity.copyTo(targetEntity);
			form.fromOrg(targetEntity,false);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
         }
            Org entity =form.toOrg();
            getService().getDraft(entity);
            form.fromOrg(entity);
            form.setSrfuf("0");
            return ResponseEntity.ok().body(form);
	}
	@GetMapping(value="main2editform/get")
	public ResponseEntity<Org_EditForm_Main2> main2EditFormGet(@Validated @NotBlank(message = "srfkey不允许为空") @RequestParam("srfkey")String srfkey){
            Org_EditForm_Main2 form=new Org_EditForm_Main2();
            Org entity = new Org();
            entity.setOrgid(srfkey);
            entity=getService().get(entity);
            form.setSrfuf("1");
            form.fromOrg(entity);
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="main2editform/create")
	public ResponseEntity<Org_EditForm_Main2> main2EditFormCreate(@Validated @RequestBody Org_EditForm_Main2 form){
            Org entity =form.toOrg();
            getService().create(entity);
            form.fromOrg(entity);
            form.setSrfuf("1");
            return ResponseEntity.ok().body(form);
	}
	@PostMapping(value="main2editform/porgname/ac")
	public ResponseEntity<List<AutoCompleteItem>> main2EditForm_porgname_ac(@RequestBody Org_EditForm_Main2 form){
		List<AutoCompleteItem> list =new ArrayList<>();
		com.sa.ibiz.demo.demo.service.dto.OrgSearchFilter searchFilter = new com.sa.ibiz.demo.demo.service.dto.OrgSearchFilter();
		Org entity =form.toOrg();
		String queryField=entity.getPorgname();
		searchFilter.getSelectCond().like("orgname",queryField);
		Page<com.sa.ibiz.demo.demo.domain.Org> searchResult = orgService.searchDefault(searchFilter);
		for(com.sa.ibiz.demo.demo.domain.Org entity2 :searchResult.getRecords()) {
			AutoCompleteItem acItem =new AutoCompleteItem();
			acItem.setValue(entity2.getOrgid());
			acItem.setText(entity2.getOrgname());
			acItem.setRealtext(entity2.getOrgname());
			list.add(acItem);
			}
		return ResponseEntity.ok().body(list);
	}
	@PostMapping(value="main2grid/update")
	public Org main2GridUpdate(@Validated Org main2Item){
		return main2Item;
	}
	@PostMapping(value="main2grid/remove")
	public ResponseEntity<Org> main2GridRemove(@Validated @RequestBody Map args){
	    Org entity =new Org();
	    if ( !StringUtils.isEmpty(args.get("srfkeys"))) {
			String srfkeys=args.get("srfkeys").toString();
			String srfkeyArr[] =srfkeys.split(";");
			for(String srfkey : srfkeyArr)
			{
				if(!StringUtils.isEmpty(srfkey)){
				entity.setOrgid(srfkey);
				this.getService().remove(entity);
                }
            }
        }
		return ResponseEntity.ok().body(entity);
	}
	public Org main2GridGet(String orgid){
		return null;
	}
	@PostMapping(value="main2grid/getdraft")
	public Org main2GridGetDraft(@Validated Org main2Item){
		return main2Item;
	}
	@PostMapping(value="main2grid/create")
	public Org main2GridCreate(@Validated Org main2Item){
		return main2Item;
	}
	@org.springframework.beans.factory.annotation.Value("${ibiz.filePath}")
    private String strFilePath;
	@Autowired
    private com.sa.ibiz.demo.ibizutil.service.IBZFILEService ibzfileService;
	/**
	 * [main2]表格数据导出
	 * @param searchFilter
	 * @return
	 * @throws
	 * @throws
	 */
	@PostMapping(value="main2grid/exportdata/searchdefault")
	public ResponseEntity<Page<JSONObject>> main2gridExportDataSearchDefault(@Validated @RequestBody OrgSearchFilter searchFilter) throws IOException, jxl.write.WriteException {
		String fileid=com.baomidou.mybatisplus.core.toolkit.IdWorker.get32UUID();
		String localPath=ExportDataInit(fileid);//输出文件相对路径
		Page<Org> searchResult = this.getService().searchDefault(searchFilter);//1.查询表格数据
		List<Map<String,Object>> datas=Org_Grid_Main2.pageToListDatas(searchResult);//2.将数据转换成list
		List<Map<String,String>> colnums=Org_Grid_Main2.getGridColumnModels();//3.获取表格列头
        java.io.File outputFile=com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.output(strFilePath+localPath,colnums,datas);//4.生成导出文件
		com.sa.ibiz.demo.ibizutil.helper.DEDataExportHelper.saveFileData(outputFile,localPath,fileid,ibzfileService); //5.保存file表记录
		String strDownloadUrl =String.format("ibizutil/download/"+fileid);//6.回传文件路径给前台
        Page<JSONObject> resultObj=Org_Grid_Main2.getResultPage(searchResult,strDownloadUrl);//7.获取输出对象
			return ResponseEntity.ok().body(resultObj);
	}
	/**
	 * 表格数据导出
	 * @param fileid
	 * @return
	 */
	private String ExportDataInit(String fileid) {
		java.text.SimpleDateFormat dateFormat = new java.text.SimpleDateFormat("yyyyMMdd");
        String filepath=dateFormat.format(new java.util.Date())+ java.io.File.separator;
        java.text.SimpleDateFormat dateFormat2 = new java.text.SimpleDateFormat("yyyyMMddHHmmss");
		String strTempFileName = fileid+"-"+dateFormat2.format(new java.util.Date())+".xls";
		java.io.File file =new java.io.File(strFilePath+filepath);
		if(!file.exists())
           file.mkdirs();
		return filepath+strTempFileName;
	}
	@PostMapping(value="main2grid/searchdefault")
	public ResponseEntity<Page<Org_Grid_Main2>> main2GridSearchDefault(@Validated @RequestBody OrgSearchFilter searchFilter){
			Page<Org> searchResult = this.getService().searchDefault(searchFilter);
			Page<Org_Grid_Main2> searchResult_vo_data =Org_Grid_Main2.fromOrg(searchResult);
					return ResponseEntity.ok().body(searchResult_vo_data);
	}
	@PostMapping(value="defaultsearchform/load")
	public void defaultSearchFormLoad(){

	}
   	@PostMapping(value="defaultsearchform/loaddraft")
	public ResponseEntity<Org_SearchForm_Default> defaultSearchFormLoadDraft(@Validated @RequestBody Org_SearchForm_Default searchform){
 		 
			OrgSearchFilter searchfilter =searchform.toOrgSearchFilter();
			searchform.fromOrgSearchFilter(searchfilter);
			return ResponseEntity.ok().body(searchform);
	} 
	@PostMapping(value="defaultsearchform/search")
	public void defaultSearchFormSearch(){
			 
	} 
 }